/*
 * Microphone_controlled_LED.c
 *
 * Created: 7/28/2018 6:30:58 PM
 *  Author: VISWESH
 */ 

#define F_CPU 1000000UL  // 1 MHz

#include <avr/io.h>
#include <util/delay.h>
#include <avr/interrupt.h>

#define LED PORTB


#define S 32
int32_t A[S];
int i=0;
uint16_t adc_read();
int x_1[] =
{
	0x01,0x02,0x04,0x03,
	0x06,0x07,0x05,0x00,
	0x01,0xF2,0x03,0x04,
	0x05,0x06,0x17,0x00
};

void demo(void);
void demo()
{
	for (int g=0;g<=16;g++)
	{
		LED = ~(x_1[g]);
		_delay_ms(50);
	}
	
}
int main(void)
{
	
	ADCSRA |= (1<<ADEN);
	ADMUX |= ( (1<<REFS1) | (1<<REFS0) ); 
	ADMUX |= 5;                           
	DDRB  = 0xFF; 
	
	demo();
	
	
	while(1)
	{
		for(int x=0;x<S/2;x++)
		{
			A[x] = adc_read();
			A[x] = A[x]/20;
			LED =~(x_1[A[x]]);
			_delay_us(5);
	    }
		
	}
}

uint16_t adc_read()
{
	volatile uint16_t retl,reth;
	//ADMUX = 0xC0;
	ADCSRA |= 1<<ADSC;
	while(ADCSRA & (1<<ADSC));  // wait until measurement done
	
	retl = ADCL;
	reth = ADCH;
	reth<<=8;
	reth|=retl;
	return reth;
}
